From db1713658859631d8df40d6dd7408902842dd353 Mon Sep 17 00:00:00 2001
From: Kedar Sovani <kedars@marvell.com>
Date: Fri, 30 Oct 2009 07:24:18 +0100
Subject: [PATCH] Fix alignment problem on ARM

Signed-off-by: Kedar Sovani <kedars@marvell.com>
---
 php-5.3.0-arm-alignment.patch |   11 +++++++++++
 php.spec                      |   10 +++++++++-
 2 files changed, 20 insertions(+), 1 deletions(-)
 create mode 100644 php-5.3.0-arm-alignment.patch

diff --git a/php-5.3.0-arm-alignment.patch b/php-5.3.0-arm-alignment.patch
new file mode 100644
index 0000000..042ab39
--- /dev/null
+++ b/php-5.3.0-arm-alignment.patch
@@ -0,0 +1,11 @@
+--- php-5.3.0/Zend/zend_execute.c.orig	2009-10-30 06:07:48.473188030 +0100
++++ php-5.3.0/Zend/zend_execute.c	2009-10-30 06:09:36.013186838 +0100
+@@ -135,7 +135,7 @@ static zend_always_inline void zend_pzva
+ #define IS_TMP_FREE(should_free) ((zend_uintptr_t)should_free.var & 1L)
+ 
+ #define INIT_PZVAL_COPY(z,v) \
+-	(z)->value = (v)->value; \
++	memcpy(&(z)->value, &(v)->value, sizeof((z)->value)); \
+ 	Z_TYPE_P(z) = Z_TYPE_P(v); \
+ 	Z_SET_REFCOUNT_P(z, 1); \
+ 	Z_UNSET_ISREF_P(z);
diff --git a/php.spec b/php.spec
index 5919bf2..798e625 100644
--- a/php.spec
+++ b/php.spec
@@ -13,7 +13,7 @@
 Summary: PHP scripting language for creating dynamic web sites
 Name: php
 Version: 5.3.0
-Release: 6%{?dist}
+Release: 6%{?dist}.fa1
 License: PHP
 Group: Development/Languages
 URL: http://www.php.net/
@@ -45,6 +45,9 @@ Patch42: php-5.3.0-systzdata-v6.patch
 # Fixes for tests
 Patch61: php-5.0.4-tests-wddx.patch
 
+# Alignment problem on ARM
+Patch80: php-5.3.0-arm-alignment.patch
+
 BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
 BuildRequires: bzip2-devel, curl-devel >= 7.9, db4-devel, gmp-devel
@@ -437,6 +440,8 @@ support for using the enchant library to PHP.
 
 %patch61 -p1 -b .tests-wddx
 
+%patch80 -p1 -b .arm-alignment
+
 # Prevent %%doc confusion over LICENSE files
 cp Zend/LICENSE Zend/ZEND_LICENSE
 cp TSRM/LICENSE TSRM_LICENSE
@@ -845,6 +850,9 @@ rm files.* macros.php
 %files enchant -f files.enchant
 
 %changelog
+* Fri Oct 30 2009 Kedar Sovani <kedars@marvell.com> 
+- Fix alignment problem on ARM
+
 * Tue Aug 25 2009 Tomas Mraz <tmraz@redhat.com> - 5.3.0-6
 - rebuilt with new openssl
 
-- 
1.5.5.6

